TFBS::DB::JASPAR4(3pm)

NAME
TFBS::DB::JASPAR4 - interface to MySQL relational database of pattern matrices

SYNOPSIS

•   creating a database object by connecting to the existing JASPAR2-type database

        my $db = TFBS::DB::JASPAR4->connect("dbi:mysql:JASPAR4:myhost",
                                            "myusername",
                                            "mypassword");

•   retrieving a TFBS::Matrix::* object from the database

        # retrieving a PFM by ID
        my $pfm = $db->get_Matrix_by_ID('M0079','PFM');

        #retrieving a PWM by name
        my $pwm = $db->get_Matrix_by_name('NF-kappaB', 'PWM');

•   retrieving a set of matrices as a TFBS::MatrixSet object according to various criteria

        # retrieving a set of PWMs from a list of IDs:
        my @IDlist = ('M0019', 'M0045', 'M0073', 'M0101');
        my $matrixset = $db->get_MatrixSet(-IDs => \@IDlist,
                                           -matrixtype => "PWM");

        # retrieving a set of ICMs from a list of names:
        my @namelist = ('p50', 'p53', 'HNF-1'. 'GATA-1', 'GATA-2', 'GATA-3');
        my $matrixset = $db->get_MatrixSet(-names => \@namelist,
                                           -matrixtype => "ICM");

        # retrieving a set of all PFMs in the database
        # derived from human genes:
        my $matrixset = $db->get_MatrixSet(-species => ['Homo sapiens'],
                                           -matrixtype => "PFM");

•   creating a new JASPAR4-type database named MYJASPAR4:

        my $db = TFBS::DB::JASPAR4->create("dbi:mysql:MYJASPAR4:myhost",
                                           "myusername",
                                           "mypassword");

•   storing a matrix in the database (currently only PFMs):

        #let $pfm is a TFBS::Matrix::PFM object
        $db->store_Matrix($pfm);

DESCRIPTION
TFBS::DB::JASPAR4 is a read/write database interface module that retrieves and stores TFBS::Matrix::* and TFBS::MatrixSet objects in a relational database. The interface is nearly identical to the JASPAR2interface, while the underlying data model is different

JASPAR2 DATA MODEL
JASPAR4 is working name for a relational database model used for storing transcriptional factor pattern matrices in a MySQL database. It was initially designed (JASPAR2) to store matrices for the JASPAR database of high quality eukaryotic transcription factor specificity profiles by Albin Sandelin and Wyeth W. Wasserman. Besides the profile matrix itself, this data model stores profile ID (unique), name, structural class, basic taxonomic and bibliographic information as well as some additional opseqdbtional tags.

Tags that are commonly used in the actual JASPAR database include
    'medline' # PubMed ID
    'species' # Species name
    'superclass' #Species supergroup, eg 'vertebrate', 'plant' etc
    'total_ic' # total information content - redundant, present
               # for historical
    'type' #experimental nethod
    'acc' #accession number for TF protein sequence
    'seqdb' #corresponding database name

but any tag is storable and searchable.

----------------------- ADVANCED ---------------------------------

For the developers and the curious, here is the JASPAR4 data model:

It is our best intention to hide the details of this data model, which we are using on a daily basis in our work, from most TFBS users. Most users should only know the methods to store the data and which tags are supported.

-------------------------------------------------------------------------

FEEDBACK
Please send bug reports and other comments to the author.

AUTHOR - Boris Lenhard
Boris Lenhard <Boris.Lenhard@cgb.ki.se>

APPENDIX
The rest of the documentation details each of the object methods. Internal methods are preceded with an underscore.

  new
 Title   : new
 Usage   : DEPRECATED - for backward compatibility only
           Use connect() or create() instead

  connect
 Title   : connect
 Usage   : my $db =
            TFBS::DB::JASPAR4->connect("dbi:mysql:DATABASENAME:HOSTNAME",
                                        "USERNAME",
                                        "PASSWORD");
 Function: connects to the existing JASPAR4-type database and
           returns a database object that interfaces the database
 Returns : a TFBS::DB::JASPAR4 object
 Args    : a standard database connection triplet
           ("dbi:mysql:DATABASENAME:HOSTNAME",  "USERNAME", "PASSWORD")
           In place of DATABASENAME, HOSTNAME, USERNAME and PASSWORD,
           use the actual values. PASSWORD and USERNAME might be
           optional, depending on the user's access permissions for
           the database server.

  dbh
 Title   : dbh
 Usage   : my $dbh = $db->dbh();
           $dbh->do("UPDATE matrix_data SET name='ADD1' WHERE NAME='SREBP2'");
 Function: returns the DBI database handle of the MySQL database
           interfaced by $db; THIS IS USED FOR WRITING NEW METHODS
           FOR DIRECT RELATIONAL DATABASE MANIPULATION - if you
           have write access AND do not know what you are doing,
           you can severely  corrupt the data
           For documentation about database handle methods, see L<DBI>
 Returns : the database (DBI) handle of the MySQL JASPAR2-type
           relational database associated with the TFBS::DB::JASPAR2
           object
 Args    : none

  store_Matrix
 Title   : store_Matrix
 Usage   : $db->store_Matrix($matrixobject);
 Function: Stores the contents of a TFBS::Matrix::DB object in the database
 Returns : 0 on success; $@ contents on failure
           (this is too C-like and may change in future versions)
 Args    : (PFM_object)
           A TFBS::Matrix::PFM, FBS::Matrix::PWM or FBS::Matrix::ICM object.
           PFM object are recommended to use, as they are eaily converted to
           other formats
 Comment : this is an experimental method that is not 100% bulletproof;
           use at your own risk

  get_Matrix_by_ID
 Title   : get_Matrix_by_ID
 Usage   : my $pfm = $db->get_Matrix_by_ID('M00034', 'PFM');
 Function: fetches matrix data under the given ID from the
           database and returns a TFBS::Matrix::* object
 Returns : a TFBS::Matrix::* object; the exact type of the
           object depending on what form the matrix is stored
           in the database (PFM is default)
 Args    : (Matrix_ID)
           Matrix_ID is a string;

  get_Matrix_by_name
 Title   : get_Matrix_by_name
 Usage   : my $pfm = $db->get_Matrix_by_name('HNF-1');
 Function: fetches matrix data under the given name from the
           database and returns a TFBS::Matrix::* object
 Returns : a TFBS::Matrix::* object; the exact type of the object
           depending on what form the matrix object was stored in
           the database (default PFM))
 Args    : (Matrix_name)

 Warning : According to the current JASPAR4 data model, name is
           not necessarily a unique identifier. In the case where
           there are several matrices with the same name in the
           database, the function fetches the first one and prints
           a warning on STDERR. You've been warned.

  get_MatrixSet
 Title   : get_MatrixSet
 Usage   : my $matrixset = $db->get_MatrixSet(%args);
 Function: fetches matrix data under for all matrices in the database
           matching criteria defined by the named arguments
           and returns a TFBS::MatrixSet object
 Returns : a TFBS::MatrixSet object
 Args    : This method accepts named arguments, corresponding to arbitrary tags.
           Note that this is different from JASPAR2. As any tag is supported for
           database storage, any tag can be used for information retrieval.
           Additionally, arguments as 'name' and 'class' can be used (even though
           they are not tags.
           As with get_Matrix methods, it is important to realize that any matrix
           format can be stored in the database: the TFBS::MatrixSet might therefore
           consist of PFMs, ICMs and PWMS, depending on how matrices are stored,

           Examples include
           -ID        # a reference to an array of IDs (strings)
           -name      # a reference to an array of
                       #  transcription factor names (string)
           -class    # a reference to an array of
                       #  structural class names (strings)
           -species    # a reference to an array of
                       #   Latin species names (strings)
           -sysgroup  # a reference to an array of
                       #  higher taxonomic categories (strings)

           -min_ic     # float, minimum total information content
                       #   of the matrix. IMPORTANT:if retrieved matrices are in PWM
                       format there is no way to measureinformation content.
        -matrixtype    #string describing type of matrix to retrieve. If left out, the format
                        will revert to the database format. Note that this option only works
                      if the database format is pfm

The arguments that expect list references are used in database query formulation: elements within lists are combined with 'OR' operators, and the lists of different types with 'AND'. For example,

    my $matrixset = $db->(-class => ['TRP_CLUSTER', 'FORKHEAD'],
                          -species => ['Homo sapiens', 'Mus musculus'],
                          );

gives a set of TFBS::Matrix::PFM objects (given that the matrix models are stored as such)
 whose (structural clas is 'TRP_CLUSTER' OR'FORKHEAD') AND (the species they are derived
 from is 'Homo sapiens'OR 'Mus musculus').

The -min_ic filter is applied after the query in the sense that the matrices profiles with total information content less than specified are not included in the set.

  delete_Matrix_having_ID
 Title   : delete_Matrix_having_ID
 Usage   : $db->delete_Matrix_with_ID('M00045');
 Function: Deletes the matrix having the given ID from the database
 Returns : 0 on success; $@ contents on failure
           (this is too C-like and may change in future versions)
 Args    : (ID)
           A string
 Comment : Yeah, yeah, 'delete_Matrix_having_ID' is a stupid name
           for a method, but at least it should be obviuos what it does.